#include "process.h"
#include "Type_defs.h"
#include "riscv.h"
#include "memlayout.h"
#include "defs.h"

extern struct PCB PCBs[];
/*
 * @brief 进程调度  mark unfinished 加锁有问题
*/
void schedule(){
    struct PCB *p;
    for(int i = KERNEL_MAX_NUM; i < MAX_PROC_NUM; i++){
        p = &PCBs[i];
        if(p->state == RUNNABLE){
            acquire_lock(&(p->lock));
            p->state = RUNNING;
            release_lock(&(p->lock));
            proc_run(p);
        } 
    }
}