#ifndef _SPINLOCK_
#define _SPINLOCK_

#include "Type_defs.h"
//#include "hart.h"

struct spinlock{
    uint32_t locked;            // 0 unlocked, 1 locked;
    char *name;
    struct hart *hart;
};

void init_lock(struct spinlock *lock, char *name);
void acquire_lock(struct spinlock *lock);
void release_lock(struct spinlock *lock);
void push_interrupt();
void pop_interrupt();
#endif