#ifndef _STDIO_
#define _STDIO_
#include "Type_defs.h"

// #define va_start(v,l)	__builtin_va_start(v,l)
// #define va_end(v)		__builtin_va_end(v)
// #define va_arg(v,l)		__builtin_va_arg(v,l)
// #define va_copy(d,s)	__builtin_va_copy(d,s)

//可变参数 参考<stdarg.h>
typedef __builtin_va_list va_list;
#define va_start(ap, last_param)  (__builtin_va_start(ap, last_param))
#define va_end(ap)              (__builtin_va_end(ap))
#define va_arg(ap, type)        (__builtin_va_arg(ap, type))

//int32_t str_put_console(const char *ch, ...);

void init_printlock();
void printf(const char *fmt, ...);
char getchar(void);
int32_t putchar(char ch);
int32_t putstr(const char *ch);
int32_t getstr(char *buff);

void panic(char *message);
#endif

