#include "string.h"
#include "stdio.h"

inline size_t strlen(const char *str){
    size_t len = 0;
    while(str[len++] != '\0');
    return len-1;
}

inline void memset(void *dst, char c, size_t n){
    char *tmp = (char*)dst;
    for(size_t i = 0; i < n; i++){
        tmp[i] = c;
    }
}


void *memcpy(void *dest, const void *src, uint32_t n){
    int i;
    const char *s = src;
    char *d = dest;

    for (i = 0; i < n; i++)
        d[i] = s[i];
    return dest;
}