#include "console.h"

/*
 * @brief   控制台初始化
 * @retval  1  成功
 * @retval  -1 失败 
 * @details 记得加锁
*/
bool console_init(void){
    //mark
    return 1;
}

/*
 * @brief 输出字符到控制台
 * @param ch 要输出的字符
 * @retval 0 or error code
*/
bool console_putchar(int32_t ch){
    bool retval;
    retval = sbi_console_putchar(ch);
    return retval;
}

/*
 * @brief 从控制台获取字符
 * @retval byte on success, or -1 for failure
*/
int32_t console_getchar(void){
    return sbi_console_getchar();
}