#ifndef _HART_
#define _HART_
#include "process.h"

struct hart{
    struct PCB *proc;
    int interrupt_depth;         // 嵌套关中断的深度
    bool pre_interrupt;          // 关中断前的中断使能状态
};

struct hart* myhart();
int32_t myhartid();
void wake_other_hart(int64_t boot_hartid);
void init_hartid(uint64_t hartid);
#endif