# start.S
#include "memlayout.h"
#include "defs.h"

	.section .text.start
	.global start       				# 内核入口

start:
	mv t0, a0							# a0存放着SBI传入的hartid，hartid从0开始
	addi t0, t0, 1
    slli t0, t0, KERNEL_STACK_SIZE_SHIFT	# 8k * (hartid+1) 栈是向下增长的
	la sp, KernelStack_start		
	add sp, sp, t0						# 为每个hart分配栈
	tail Kernel_Init					# 跳转到内核

	.section .data.stack
	.align 12							# 按4k对齐(一页的大小)
	.global KernelStack_start
KernelStack_start:
	.space (KERNEL_MAX_NUM * KERNEL_STACK_SIZE)		# 内核栈 * 内核数
	.global KernelStack_top
	
KernelStack_top:
